"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = then;

var _internal = require("./-internal");

var _asap = require("./asap");

function then(onFulfillment, onRejection) {
  var parent = this;
  var child = new this.constructor(_internal.noop);

  if (child[_internal.PROMISE_ID] === undefined) {
    (0, _internal.makePromise)(child);
  }

  var _state = parent._state;

  if (_state) {
    var callback = arguments[_state - 1];
    (0, _asap.asap)(function () {
      return (0, _internal.invokeCallback)(_state, child, callback, parent._result);
    });
  } else {
    (0, _internal.subscribe)(parent, child, onFulfillment, onRejection);
  }

  return child;
}

module.exports = exports.default;